#
# Server, sicherer Interpreter, mehrere Verbindungen
#

#***************
proc server_accept {chan addr port} {
	fileevent $chan readable "server_do $chan"
	fconfigure $chan -buffering line
	puts "Verbindung: $chan $addr $port"
}

#***************
proc server_do {chan} {
	global safe
	set cmd [gets $chan]
	puts $cmd
    if {[catch {puts $chan [$safe eval $cmd]}]} {
		if {[catch {puts $chan "$cmd???"}]} {
			puts "Client $chan nicht mehr erreichbar!"
			close $chan
		}
	}	
}
 
#***************
proc safe_addiere {a b} {
	return [expr $a + $b]
}

#***************
#***************
set safe [interp create -safe]
$safe alias addiere safe_addiere

socket -server server_accept 12345

vwait forever
